/* Copyright (c) 2008-2009, Code Aurora Forum. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Code Aurora Forum nor
 *       the names of its contributors may be used to endorse or promote
 *       products derived from this software without specific prior written
 *       permission.
 *
 * Alternatively, provided that this notice is retained in full, this software
 * may be relicensed by the recipient under the terms of the GNU General Public
 * License version 2 ("GPL") and only version 2, in which case the provisions of
 * the GPL apply INSTEAD OF those given above.  If the recipient relicenses the
 * software under the GPL, then the identification text in the MODULE_LICENSE
 * macro must be changed to reflect "GPLv2" instead of "Dual BSD/GPL".  Once a
 * recipient changes the license terms to the GPL, subsequent recipients shall
 * not relicense under alternate licensing terms, including the BSD or dual
 * BSD/GPL terms.  In addition, the following license statement immediately
 * below and between the words START and END shall also then apply when this
 * software is relicensed under the GPL:
 *
 * START
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License version 2 and only version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * END
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include "s5k4e1gx.h"


struct s5k4e1gx_i2c_reg_conf
lens_correction_preview[] = {
	{0x3097, 0x52},
	{0x3098, 0x3e},
	{0x3099, 0x03},
	{0x309a, 0x1f},
	{0x309b, 0x04},
	{0x309c, 0x21},
};

struct s5k4e1gx_i2c_reg_conf
lens_correction_capture[] = {
	{0x3097, 0x52},
	{0x3098, 0x7b},
	{0x3099, 0x03},
	{0x309a, 0x1f},
	{0x309b, 0x02},
	{0x309c, 0x15},
};

struct s5k4e1gx_i2c_reg_conf
lens_correction_common[] = {
	{0x3096, 0x40},
	{0x309d, 0x00},
	{0x309e, 0x00},
	{0x309f, 0x00},
	{0x30a0, 0x00},
	{0x30a1, 0x00},
	{0x30a2, 0x00},
	{0x30a3, 0x00},
	{0x30a4, 0x00},
	{0x30a5, 0x01},
	{0x30a6, 0x00},
	{0x3200, 0x00},
	{0x3201, 0xb7},
	{0x3202, 0xb1},
	{0x3203, 0x0f},
	{0x3204, 0xac},
	{0x3205, 0x8b},
	{0x3206, 0x00},
	{0x3207, 0x47},
	{0x3208, 0xa8},
	{0x3209, 0x0f},
	{0x320a, 0xdb},
	{0x320b, 0x56},
	{0x320c, 0x00},
	{0x320d, 0x02},
	{0x320e, 0x6e},
	{0x320f, 0x00},
	{0x3210, 0x1e},
	{0x3211, 0x05},
	{0x3212, 0x0f},
	{0x3213, 0x73},
	{0x3214, 0x07},
	{0x3215, 0x00},
	{0x3216, 0x7a},
	{0x3217, 0x35},
	{0x3218, 0x0f},
	{0x3219, 0x89},
	{0x321a, 0x39},
	{0x321b, 0x00},
	{0x321c, 0x41},
	{0x321d, 0xbf},
	{0x321e, 0x00},
	{0x321f, 0x18},
	{0x3220, 0x8e},
	{0x3221, 0x0f},
	{0x3222, 0xa4},
	{0x3223, 0x4a},
	{0x3224, 0x00},
	{0x3225, 0xac},
	{0x3226, 0x53},
	{0x3227, 0x0f},
	{0x3228, 0x5a},
	{0x3229, 0xc3},
	{0x322a, 0x00},
	{0x322b, 0x88},
	{0x322c, 0x5c},
	{0x322d, 0x0f},
	{0x322e, 0xc9},
	{0x322f, 0x56},
	{0x3230, 0x0f},
	{0x3231, 0xd2},
	{0x3232, 0x1a},
	{0x3233, 0x00},
	{0x3234, 0x7d},
	{0x3235, 0x30},
	{0x3236, 0x0f},
	{0x3237, 0x5a},
	{0x3238, 0x80},
	{0x3239, 0x00},
	{0x323a, 0x8e},
	{0x323b, 0x9d},
	{0x323c, 0x0f},
	{0x323d, 0xa8},
	{0x323e, 0xad},
	{0x323f, 0x00},
	{0x3240, 0x15},
	{0x3241, 0x86},
	{0x3242, 0x00},
	{0x3243, 0x16},
	{0x3244, 0xac},
	{0x3245, 0x0f},
	{0x3246, 0xa1},
	{0x3247, 0x60},
	{0x3248, 0x00},
	{0x3249, 0x62},
	{0x324a, 0x18},
	{0x324b, 0x0f},
	{0x324c, 0xe9},
	{0x324d, 0x95},
	{0x324e, 0x0f},
	{0x324f, 0xd8},
	{0x3250, 0xc4},
	{0x3251, 0x00},
	{0x3252, 0x23},
	{0x3253, 0xf7},
	{0x3254, 0x00},
	{0x3255, 0x22},
	{0x3256, 0x2d},
	{0x3257, 0x0f},
	{0x3258, 0xf9},
	{0x3259, 0x4b},
	{0x325a, 0x0f},
	{0x325b, 0xf9},
	{0x325c, 0x3e},
	{0x325d, 0x0f},
	{0x325e, 0xbd},
	{0x325f, 0x6f},
	{0x3260, 0x00},
	{0x3261, 0x65},
	{0x3262, 0x74},
	{0x3263, 0x0f},
	{0x3264, 0xc7},
	{0x3265, 0x51},
	{0x3266, 0x0f},
	{0x3267, 0xcd},
	{0x3268, 0xe8},
	{0x3269, 0x00},
	{0x326a, 0x41},
	{0x326b, 0xd5},
	{0x326c, 0x00},
	{0x326d, 0xbb},
	{0x326e, 0x25},
	{0x326f, 0x0f},
	{0x3270, 0xaf},
	{0x3271, 0x31},
	{0x3272, 0x00},
	{0x3273, 0x40},
	{0x3274, 0xc2},
	{0x3275, 0x0f},
	{0x3276, 0xe5},
	{0x3277, 0xb4},
	{0x3278, 0x0f},
	{0x3279, 0xfb},
	{0x327a, 0x36},
	{0x327b, 0x00},
	{0x327c, 0x20},
	{0x327d, 0x66},
	{0x327e, 0x0f},
	{0x327f, 0x6d},
	{0x3280, 0x8e},
	{0x3281, 0x00},
	{0x3282, 0x78},
	{0x3283, 0xd5},
	{0x3284, 0x0f},
	{0x3285, 0x90},
	{0x3286, 0x69},
	{0x3287, 0x00},
	{0x3288, 0x38},
	{0x3289, 0x94},
	{0x328a, 0x00},
	{0x328b, 0x18},
	{0x328c, 0x99},
	{0x328d, 0x0f},
	{0x328e, 0xa7},
	{0x328f, 0xc0},
	{0x3290, 0x00},
	{0x3291, 0xb6},
	{0x3292, 0xb1},
	{0x3293, 0x0f},
	{0x3294, 0x5c},
	{0x3295, 0xf9},
	{0x3296, 0x00},
	{0x3297, 0x7c},
	{0x3298, 0x23},
	{0x3299, 0x0f},
	{0x329a, 0xd7},
	{0x329b, 0x5a},
	{0x329c, 0x0f},
	{0x329d, 0xdc},
	{0x329e, 0x78},
	{0x329f, 0x00},
	{0x32a0, 0x6b},
	{0x32a1, 0xb1},
	{0x32a2, 0x0f},
	{0x32a3, 0x49},
	{0x32a4, 0xf5},
	{0x32a5, 0x00},
	{0x32a6, 0x8a},
	{0x32a7, 0xbe},
	{0x32a8, 0x0f},
	{0x32a9, 0xb0},
	{0x32aa, 0xe8},
	{0x32ab, 0x00},
	{0x32ac, 0x08},
	{0x32ad, 0x61},
	{0x32ae, 0x00},
	{0x32af, 0x0c},
	{0x32b0, 0xba},
	{0x32b1, 0x0f},
	{0x32b2, 0xb1},
	{0x32b3, 0x98},
	{0x32b4, 0x00},
	{0x32b5, 0x76},
	{0x32b6, 0x36},
	{0x32b7, 0x0f},
	{0x32b8, 0xe9},
	{0x32b9, 0xc2},
	{0x32ba, 0x0f},
	{0x32bb, 0xee},
	{0x32bc, 0x35},
	{0x32bd, 0x00},
	{0x32be, 0x0d},
	{0x32bf, 0x27},
	{0x32c0, 0x00},
	{0x32c1, 0x36},
	{0x32c2, 0xbc},
	{0x32c3, 0x0f},
	{0x32c4, 0xf3},
	{0x32c5, 0x19},
	{0x32c6, 0x0f},
	{0x32c7, 0xec},
	{0x32c8, 0x9f},
	{0x32c9, 0x0f},
	{0x32ca, 0xc1},
	{0x32cb, 0x86},
	{0x32cc, 0x00},
	{0x32cd, 0x41},
	{0x32ce, 0xe5},
	{0x32cf, 0x0f},
	{0x32d0, 0xf4},
	{0x32d1, 0x3e},
	{0x32d2, 0x0f},
	{0x32d3, 0xb2},
	{0x32d4, 0x3d},
	{0x32d5, 0x00},
	{0x32d6, 0x43},
	{0x32d7, 0x91},
	{0x32d8, 0x00},
	{0x32d9, 0xa0},
	{0x32da, 0x4a},
	{0x32db, 0x0f},
	{0x32dc, 0xbc},
	{0x32dd, 0xe5},
	{0x32de, 0x00},
	{0x32df, 0x36},
	{0x32e0, 0x92},
	{0x32e1, 0x0f},
	{0x32e2, 0xe7},
	{0x32e3, 0x64},
	{0x32e4, 0x00},
	{0x32e5, 0x04},
	{0x32e6, 0x24},
	{0x32e7, 0x00},
	{0x32e8, 0x11},
	{0x32e9, 0xe6},
	{0x32ea, 0x0f},
	{0x32eb, 0x7d},
	{0x32ec, 0xbf},
	{0x32ed, 0x00},
	{0x32ee, 0x75},
	{0x32ef, 0x18},
	{0x32f0, 0x0f},
	{0x32f1, 0x8d},
	{0x32f2, 0x7a},
	{0x32f3, 0x00},
	{0x32f4, 0x40},
	{0x32f5, 0x83},
	{0x32f6, 0x00},
	{0x32f7, 0x15},
	{0x32f8, 0xe6},
	{0x32f9, 0x0f},
	{0x32fa, 0xaa},
	{0x32fb, 0x2a},
	{0x32fc, 0x00},
	{0x32fd, 0xb1},
	{0x32fe, 0x44},
	{0x32ff, 0x0f},
	{0x3300, 0x64},
	{0x3301, 0x7b},
	{0x3302, 0x00},
	{0x3303, 0x76},
	{0x3304, 0xce},
	{0x3305, 0x0f},
	{0x3306, 0xdc},
	{0x3307, 0xcd},
	{0x3308, 0x0f},
	{0x3309, 0xc1},
	{0x330a, 0xeb},
	{0x330b, 0x00},
	{0x330c, 0x81},
	{0x330d, 0x87},
	{0x330e, 0x0f},
	{0x330f, 0x3e},
	{0x3310, 0x9d},
	{0x3311, 0x00},
	{0x3312, 0x86},
	{0x3313, 0x13},
	{0x3314, 0x0f},
	{0x3315, 0xb9},
	{0x3316, 0x93},
	{0x3317, 0x00},
	{0x3318, 0x08},
	{0x3319, 0xd4},
	{0x331a, 0x00},
	{0x331b, 0x1e},
	{0x331c, 0xdc},
	{0x331d, 0x0f},
	{0x331e, 0x9d},
	{0x331f, 0xe5},
	{0x3320, 0x00},
	{0x3321, 0x8e},
	{0x3322, 0x6d},
	{0x3323, 0x0f},
	{0x3324, 0xe4},
	{0x3325, 0xe3},
	{0x3326, 0x0f},
	{0x3327, 0xdf},
	{0x3328, 0xb3},
	{0x3329, 0x00},
	{0x332a, 0x07},
	{0x332b, 0x96},
	{0x332c, 0x00},
	{0x332d, 0x44},
	{0x332e, 0xa8},
	{0x332f, 0x0f},
	{0x3330, 0xec},
	{0x3331, 0x6c},
	{0x3332, 0x0f},
	{0x3333, 0xd8},
	{0x3334, 0x9b},
	{0x3335, 0x0f},
	{0x3336, 0xc9},
	{0x3337, 0xd7},
	{0x3338, 0x00},
	{0x3339, 0x50},
	{0x333a, 0x5f},
	{0x333b, 0x0f},
	{0x333c, 0xf2},
	{0x333d, 0x88},
	{0x333e, 0x0f},
	{0x333f, 0x9f},
	{0x3340, 0x6b},
	{0x3341, 0x00},
	{0x3342, 0x53},
	{0x3343, 0x61},
	{0x3344, 0x00},
	{0x3345, 0xb7},
	{0x3346, 0x67},
	{0x3347, 0x0f},
	{0x3348, 0xaa},
	{0x3349, 0x3a},
	{0x334a, 0x00},
	{0x334b, 0x4f},
	{0x334c, 0xb5},
	{0x334d, 0x0f},
	{0x334e, 0xce},
	{0x334f, 0x48},
	{0x3350, 0x00},
	{0x3351, 0x15},
	{0x3352, 0xa1},
	{0x3353, 0x00},
	{0x3354, 0x0e},
	{0x3355, 0xd8},
	{0x3356, 0x0f},
	{0x3357, 0x6b},
	{0x3358, 0x37},
	{0x3359, 0x00},
	{0x335a, 0x84},
	{0x335b, 0xd1},
	{0x335c, 0x0f},
	{0x335d, 0x7f},
	{0x335e, 0x0b},
	{0x335f, 0x00},
	{0x3360, 0x4d},
	{0x3361, 0x88},
	{0x3362, 0x00},
	{0x3363, 0x04},
	{0x3364, 0xb6},
	{0x3365, 0x0f},
	{0x3366, 0xb7},
	{0x3367, 0x06},
	{0x3368, 0x00},
	{0x3369, 0xb8},
	{0x336a, 0xa0},
	{0x336b, 0x0f},
	{0x336c, 0x4d},
	{0x336d, 0xc9},
	{0x336e, 0x00},
	{0x336f, 0x89},
	{0x3370, 0x33},
	{0x3371, 0x0f},
	{0x3372, 0xcd},
	{0x3373, 0xf1},
	{0x3374, 0x0f},
	{0x3375, 0xd6},
	{0x3376, 0xaa},
	{0x3377, 0x00},
	{0x3378, 0x72},
	{0x3379, 0x67},
	{0x337a, 0x0f},
	{0x337b, 0x4f},
	{0x337c, 0xd6},
	{0x337d, 0x00},
	{0x337e, 0x97},
	{0x337f, 0xa7},
	{0x3380, 0x0f},
	{0x3381, 0xb0},
	{0x3382, 0xd4},
	{0x3383, 0x00},
	{0x3384, 0x03},
	{0x3385, 0xdf},
	{0x3386, 0x00},
	{0x3387, 0x26},
	{0x3388, 0xb1},
	{0x3389, 0x0f},
	{0x338a, 0x97},
	{0x338b, 0x35},
	{0x338c, 0x00},
	{0x338d, 0x68},
	{0x338e, 0x50},
	{0x338f, 0x0f},
	{0x3390, 0xe6},
	{0x3391, 0xef},
	{0x3392, 0x0f},
	{0x3393, 0xd6},
	{0x3394, 0x91},
	{0x3395, 0x00},
	{0x3396, 0x25},
	{0x3397, 0xfd},
	{0x3398, 0x00},
	{0x3399, 0x13},
	{0x339a, 0xa1},
	{0x339b, 0x00},
	{0x339c, 0x14},
	{0x339d, 0x2d},
	{0x339e, 0x0f},
	{0x339f, 0xf7},
	{0x33a0, 0xa6},
	{0x33a1, 0x0f},
	{0x33a2, 0xbd},
	{0x33a3, 0x8a},
	{0x33a4, 0x00},
	{0x33a5, 0x5b},
	{0x33a6, 0x64},
	{0x33a7, 0x0f},
	{0x33a8, 0xdc},
	{0x33a9, 0x72},
	{0x33aa, 0x0f},
	{0x33ab, 0xc8},
	{0x33ac, 0x06},
	{0x33ad, 0x00},
	{0x33ae, 0x2f},
	{0x33af, 0xd8},
	{0x3096, 0x60},
	{0x3096, 0x40},
};

struct s5k4e1gx_i2c_reg_conf
reg_analog_settings_evt2[] = {
	{0x3000, 0x04},
	{0x3001, 0x02},
	{0x3002, 0x0C},
	{0x3003, 0x0E},
	{0x3004, 0x2C},
	{0x3005, 0x0D},
	{0x3006, 0x39},
	{0x3007, 0x02},
	{0x3008, 0x3C},
	{0x3009, 0x3C},
	{0x300A, 0x28},
	{0x300B, 0x15},
	{0x300C, 0x15},
	{0x300D, 0x02},
	{0x3010, 0x00},
	{0x3011, 0x7A},
	{0x3012, 0x30},
	{0x3013, 0x90},
	{0x3014, 0x00},
	{0x3015, 0x00},
	{0x3016, 0x02},
	{0x3017, 0x84},
	{0x3018, 0x78},
	{0x301B, 0x77},
	{0x301D, 0xD4},
	{0x3021, 0x02},
	{0x3022, 0x44},
	{0x3024, 0x40},
	{0x3027, 0x08},
	{0x301C, 0x05},
	{0x30D8, 0x3F},
	{0x3070, 0x5F},
	{0x3071, 0x00},
	{0x3080, 0x04},
	{0x3081, 0x38},
	{0x3084, 0x15},
	{0x30BE, 0x1A},
	{0x30E2, 0x01},
};

struct s5k4e1gx_i2c_reg_conf
reg_analog_settings_evt3[] = {
	{0x3000, 0x05},
	{0x3001, 0x03},
	{0x3002, 0x08},
	{0x3003, 0x09},
	{0x3004, 0x2E},
	{0x3005, 0x06},
	{0x3006, 0x34},
	{0x3007, 0x00},
	{0x3008, 0x3C},
	{0x3009, 0x3C},
	{0x300A, 0x28},
	{0x300B, 0x04},
	{0x300C, 0x0A},
	{0x300D, 0x02},
	{0x300F, 0x82},
	{0x3010, 0x00},
	{0x3011, 0x4C},
	{0x3012, 0x30},
	{0x3013, 0xC0},
	{0x3014, 0x00},
	{0x3015, 0x00},
	{0x3016, 0x2C},
	{0x3017, 0x94},
	{0x3018, 0x78},
	{0x301B, 0x83},
	{0x301D, 0xD4},
	{0x3021, 0x02},
	{0x3022, 0x24},
	{0x3024, 0x40},
	{0x3027, 0x08},
	{0x3029, 0xC6},
	{0x302B, 0x00},
	{0x30BC, 0xA0},		//0xE0,	//0xC0
	{0x301C, 0x04},
	{0x30D8, 0x3F},
	{0x3070, 0x5F},
	{0x3071, 0x00},
	{0x3080, 0x04},
	{0x3081, 0x38},
	{0x3084, 0x15},
	{0x30BE, 0x08},		//0x1A,	//0x08
	{0x30E2, 0x01},
};

struct s5k4e1gx_reg_t s5k4e1gx_regs = {
	.lc_preview = &lens_correction_preview[0],
	.lc_preview_size = ARRAY_SIZE(lens_correction_preview),
	.lc_capture = &lens_correction_capture[0],
	.lc_capture_size = ARRAY_SIZE(lens_correction_capture),
	.lc_common = &lens_correction_common[0],
	.lc_common_size = ARRAY_SIZE(lens_correction_common),
	.analog_settings_evt2 = &reg_analog_settings_evt2[0],
	.analog_settings_evt2_size = ARRAY_SIZE(reg_analog_settings_evt2),
	.analog_settings_evt3 = &reg_analog_settings_evt3[0],
	.analog_settings_evt3_size = ARRAY_SIZE(reg_analog_settings_evt3)
};



